<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>propclass/neuralnet.h Source File (CEL: Crystal Entity Layer 2.0 Public API Reference)</title>
<link href="tabs.css" rel="stylesheet" type="text/css">
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<table border="0" cellpadding="0" cellspacing="0" width="100%" class="head">
 <tr height="59">
  <td class="head" width="202" valign="bottom" style="padding-left:0;"><a href="http://cel.crystalspace3d.org/"><img src="celblur.png" width="210" height="59" alt="CEL" border="0"></a></td>
  <td class="head"><h2>Public API Reference</h2></td>
 </tr>
 <tr height="11">
  <td colspan="2" class="headshadow" valign="top" style="padding-left:0;"><img src="celshadow.png" width="9" height="11" alt="" border="0"></td>
 </tr>
</table>
<div class="content">
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">propclass/neuralnet.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    Crystal Space Entity Layer</span>
<a name="l00003"></a>00003 <span class="comment">    Copyright (C) 2007 by Jorrit Tyberghein</span>
<a name="l00004"></a>00004 <span class="comment"></span>
<a name="l00005"></a>00005 <span class="comment">    Neural Network Property Class</span>
<a name="l00006"></a>00006 <span class="comment">    Copyright (C) 2007 by Mat Sutcliffe</span>
<a name="l00007"></a>00007 <span class="comment"></span>
<a name="l00008"></a>00008 <span class="comment">    This library is free software; you can redistribute it and/or</span>
<a name="l00009"></a>00009 <span class="comment">    modify it under the terms of the GNU Library General Public</span>
<a name="l00010"></a>00010 <span class="comment">    License as published by the Free Software Foundation; either</span>
<a name="l00011"></a>00011 <span class="comment">    version 2 of the License, or (at your option) any later version.</span>
<a name="l00012"></a>00012 <span class="comment"></span>
<a name="l00013"></a>00013 <span class="comment">    This library is distributed in the hope that it will be useful,</span>
<a name="l00014"></a>00014 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00015"></a>00015 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00016"></a>00016 <span class="comment">    Library General Public License for more details.</span>
<a name="l00017"></a>00017 <span class="comment"></span>
<a name="l00018"></a>00018 <span class="comment">    You should have received a copy of the GNU Library General Public</span>
<a name="l00019"></a>00019 <span class="comment">    License along with this library; if not, write to the Free</span>
<a name="l00020"></a>00020 <span class="comment">    Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.</span>
<a name="l00021"></a>00021 <span class="comment">*/</span>
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 <span class="preprocessor">#ifndef __CEL_PF_NEURALNET__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span><span class="preprocessor">#define __CEL_PF_NEURALNET__</span>
<a name="l00025"></a>00025 <span class="preprocessor"></span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/cstypes_8h.html">cstypes.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/scf_8h.html">csutil/scf.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/refcount_8h.html">csutil/refcount.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/csutil_2array_8h.html">csutil/array.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/math_8h.html">csgeom/math.h</a>&quot;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;physicallayer/datatype.h&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="keyword">class </span><a class="code" href="classcelNNActivationFunc.html" title="Abstract class representing an activation function callback for the neural network property class...">celNNActivationFunc</a>;
<a name="l00035"></a>00035 
<a name="l00049"></a><a class="code" href="structiCelNNWeights.html">00049</a> <span class="keyword">struct </span><a class="code" href="structiCelNNWeights.html" title="Structure which can hold the weightings of all links between the nodes of an iPcNeuralNet property cl...">iCelNNWeights</a> : <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>
<a name="l00050"></a>00050 { 
<a name="l00051"></a>00051   SCF_INTERFACE(<a class="code" href="structiCelNNWeights.html" title="Structure which can hold the weightings of all links between the nodes of an iPcNeuralNet property cl...">iCelNNWeights</a>, 0, 0, 1);
<a name="l00052"></a>00052 
<a name="l00054"></a>00054   <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsArray.html">csArray&lt; csArray&lt; csArray&lt;float&gt;</a> &gt; &gt;&amp; <a class="code" href="structiCelNNWeights.html#afeff18d971cac76e166e172d5f849ef8" title="Access the weighting data (non-const). Use with care.">Data</a>() = 0;
<a name="l00055"></a>00055 
<a name="l00057"></a>00057   <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsArray.html">csArray&lt; csArray&lt; csArray&lt;float&gt;</a> &gt; &gt;&amp; <a class="code" href="structiCelNNWeights.html#afeff18d971cac76e166e172d5f849ef8" title="Access the weighting data (non-const). Use with care.">Data</a>() <span class="keyword">const</span> = 0;
<a name="l00058"></a>00058 
<a name="l00060"></a>00060   <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsPtr.html">csPtr&lt;iCelNNWeights&gt;</a> <a class="code" href="structiCelNNWeights.html#a502e28689deced562bb143409652fdc1" title="Returns a new structure which is a copy of this one.">Clone</a>() <span class="keyword">const</span> = 0;
<a name="l00061"></a>00061 };
<a name="l00062"></a>00062 
<a name="l00095"></a><a class="code" href="structiPcNeuralNet.html">00095</a> <span class="keyword">struct </span><a class="code" href="structiPcNeuralNet.html" title="A property class implementing a feed-forward neural network.">iPcNeuralNet</a> : <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>
<a name="l00096"></a>00096 {
<a name="l00097"></a>00097   SCF_INTERFACE(<a class="code" href="structiPcNeuralNet.html" title="A property class implementing a feed-forward neural network.">iPcNeuralNet</a>, 0, 0, 1);
<a name="l00098"></a>00098 
<a name="l00103"></a>00103   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcNeuralNet.html#a0f931a2f212e050df968fb68b623dbc9" title="Sets the size of the neural network (number of inputs, outputs and hidden layers).">SetSize</a>(<span class="keywordtype">size_t</span> inputs, <span class="keywordtype">size_t</span> outputs, <span class="keywordtype">size_t</span> layers) = 0;
<a name="l00104"></a>00104 
<a name="l00115"></a>00115   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcNeuralNet.html#a244ce5d34b7b4e4185777defa71eefc0" title="Sets the heuristic that will be used to set the sizes of each layer.">SetComplexity</a>(<span class="keyword">const</span> <span class="keywordtype">char</span> *name) = 0;
<a name="l00116"></a>00116 
<a name="l00123"></a>00123   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcNeuralNet.html#a089dd8c8c13da27211bfbf60c55196b1" title="Manually set the number of nodes in each hidden layer.">SetLayerSizes</a>(<span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsArray.html">csArray&lt;size_t&gt;</a> &amp;sizes) = 0;
<a name="l00124"></a>00124 
<a name="l00128"></a>00128   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcNeuralNet.html#a3ea5bf4ad84cf46b611c0f7ec68f6a87" title="Sets the activation function of the neural network.">SetActivationFunc</a>(<a class="code" href="classcelNNActivationFunc.html" title="Abstract class representing an activation function callback for the neural network property class...">celNNActivationFunc</a> *) = 0;
<a name="l00129"></a>00129 
<a name="l00135"></a>00135   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiPcNeuralNet.html#a64142c300a25cddb5d8ab688e2e6e805" title="Returns true if the neural network is initialized and ready to use.">Validate</a>() = 0;
<a name="l00136"></a>00136 
<a name="l00140"></a>00140   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcNeuralNet.html#aaef26b7ad64b6ffaf33a73b8e5715962" title="Sets the value of one of the inputs.">SetInput</a>(<span class="keywordtype">size_t</span> index, <span class="keyword">const</span> <a class="code" href="structcelData.html" title="Typed data for CEL.">celData</a> &amp;value) = 0;
<a name="l00141"></a>00141 
<a name="l00145"></a>00145   <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="structcelData.html" title="Typed data for CEL.">celData</a>&amp; <a class="code" href="structiPcNeuralNet.html#a93498479e05f79c9bc80fb5260600e20" title="Returns the value of one of the outputs.">GetOutput</a>(<span class="keywordtype">size_t</span> index) <span class="keyword">const</span> = 0;
<a name="l00146"></a>00146 
<a name="l00150"></a>00150   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcNeuralNet.html#ac7325112d5db4779b6142e368a9298f0" title="Sets all the input values in one go.">SetInputs</a>(<span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsArray.html">csArray&lt;celData&gt;</a> &amp;values) = 0;
<a name="l00151"></a>00151 
<a name="l00155"></a>00155   <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsArray.html">csArray&lt;celData&gt;</a>&amp; <a class="code" href="structiPcNeuralNet.html#a40709c857a4f769d52bd5886aab5cec3" title="Retrieves all the output values in one go.">GetOutputs</a>() <span class="keyword">const</span> = 0;
<a name="l00156"></a>00156 
<a name="l00161"></a>00161   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcNeuralNet.html#a1f0fb6bad9d6ec726e9a14cc9e817a55" title="Runs one iteration through the network, reading the inputs and setting the outputs.">Process</a>() = 0;
<a name="l00162"></a>00162 
<a name="l00166"></a>00166   <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsPtr.html">csPtr&lt;iCelNNWeights&gt;</a> <a class="code" href="structiPcNeuralNet.html#a56597977382b31f14a956d0448481776" title="Returns a new weights structure with the same size as the current one.">CreateEmptyWeights</a>() <span class="keyword">const</span> = 0;
<a name="l00167"></a>00167 
<a name="l00171"></a>00171   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcNeuralNet.html#a98a30b06e65a05355645c6d80dab7944" title="Copies the weightings of the neural network into the structure provided.">GetWeights</a>(<a class="code" href="structiCelNNWeights.html" title="Structure which can hold the weightings of all links between the nodes of an iPcNeuralNet property cl...">iCelNNWeights</a> *out) <span class="keyword">const</span> = 0;
<a name="l00172"></a>00172 
<a name="l00176"></a>00176   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiPcNeuralNet.html#ac3ec5813085cc15644722545071edf2c" title="Copies the weightings into the neural network from the given structure.">SetWeights</a>(<span class="keyword">const</span> <a class="code" href="structiCelNNWeights.html" title="Structure which can hold the weightings of all links between the nodes of an iPcNeuralNet property cl...">iCelNNWeights</a> *in) = 0;
<a name="l00177"></a>00177 
<a name="l00181"></a>00181   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiPcNeuralNet.html#a7b08a79cdc66cf374f67814d66e5ed14" title="Saves the weightings to cache with an iCacheManager.">CacheWeights</a>(<span class="keyword">const</span> <span class="keywordtype">char</span> *scope, <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gacbd4acd0d29e2d6c43104827f77d9cd2">uint32</a> <span class="keywordtype">id</span>) <span class="keyword">const</span> = 0;
<a name="l00182"></a>00182 
<a name="l00186"></a>00186   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiPcNeuralNet.html#a812e20c1b378a6f28c5cf54807ad5516" title="Loads the weightings from cache with an iCacheManager.">LoadCachedWeights</a>(<span class="keyword">const</span> <span class="keywordtype">char</span> *scope, <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gacbd4acd0d29e2d6c43104827f77d9cd2">uint32</a> <span class="keywordtype">id</span>) = 0;
<a name="l00187"></a>00187 };
<a name="l00188"></a>00188 
<a name="l00202"></a><a class="code" href="classcelNNActivationFunc.html">00202</a> <span class="keyword">class </span><a class="code" href="classcelNNActivationFunc.html" title="Abstract class representing an activation function callback for the neural network property class...">celNNActivationFunc</a> : <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsRefCount.html">csRefCount</a>
<a name="l00203"></a>00203 {
<a name="l00204"></a>00204 <span class="keyword">public</span>:
<a name="l00206"></a>00206   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classcelNNActivationFunc.html#af6fa30c106acfc347c3c4d9802e34c90" title="The callback method. Performs the activation function on the data.">Function</a>(<a class="code" href="structcelData.html" title="Typed data for CEL.">celData</a> &amp;data) = 0;
<a name="l00207"></a>00207 
<a name="l00209"></a>00209   <span class="keyword">virtual</span> celDataType <a class="code" href="classcelNNActivationFunc.html#a55cf5cd8747b85c740ef50664c59ab50" title="Returns the type of data upon which this function operates.">GetDataType</a>() = 0;
<a name="l00210"></a>00210 
<a name="l00212"></a><a class="code" href="classcelNNActivationFunc.html#a491588dcfe705ca49ef29059c0d84ef9">00212</a>   <span class="keyword">virtual</span> <a class="code" href="classcelNNActivationFunc.html#a491588dcfe705ca49ef29059c0d84ef9" title="Destructor.">~celNNActivationFunc</a>() {}
<a name="l00213"></a>00213 
<a name="l00214"></a>00214 <span class="keyword">protected</span>:
<a name="l00226"></a>00226   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00227"></a>00227   <span class="keyword">static</span> <span class="keyword">const</span> T&amp; <a class="code" href="classcelNNActivationFunc.html#aa32d09db692e0326f60f416a351dc486" title="Convenience template for subclasses of celNNActivationFunc.">GetFrom</a>(<span class="keyword">const</span> <a class="code" href="structcelData.html" title="Typed data for CEL.">celData</a> &amp;input);
<a name="l00228"></a>00228 
<a name="l00239"></a>00239   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00240"></a>00240   <span class="keyword">static</span> celDataType <a class="code" href="classcelNNActivationFunc.html#a996ea992143b42b31e19b069ff04dd61" title="Convenience template for subclasses of celNNActivationFunc.">DataType</a>();
<a name="l00241"></a>00241 };
<a name="l00242"></a>00242 
<a name="l00243"></a>00243 <span class="keyword">template</span>&lt;&gt;
<a name="l00244"></a><a class="code" href="classcelNNActivationFunc.html#aa32d09db692e0326f60f416a351dc486">00244</a> <span class="keyword">inline</span> <span class="keyword">const</span> <span class="keywordtype">float</span>&amp; celNNActivationFunc::GetFrom&lt;float&gt;(<span class="keyword">const</span> <a class="code" href="structcelData.html" title="Typed data for CEL.">celData</a> &amp;input)
<a name="l00245"></a>00245 {
<a name="l00246"></a>00246   <span class="keywordflow">return</span> input.value.f;
<a name="l00247"></a>00247 }
<a name="l00248"></a>00248 <span class="keyword">template</span>&lt;&gt;
<a name="l00249"></a>00249 <span class="keyword">inline</span> <span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gaa79c2d3de4fcd200458c406f40b2ae64">int8</a>&amp; celNNActivationFunc::GetFrom&lt;int8&gt;(<span class="keyword">const</span> <a class="code" href="structcelData.html" title="Typed data for CEL.">celData</a> &amp;input)
<a name="l00250"></a>00250 {
<a name="l00251"></a>00251   <span class="keywordflow">return</span> input.value.b;
<a name="l00252"></a>00252 }
<a name="l00253"></a>00253 <span class="keyword">template</span>&lt;&gt;
<a name="l00254"></a>00254 <span class="keyword">inline</span> <span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga33a5e996e7a90acefb8b1c0bea47e365">uint8</a>&amp; celNNActivationFunc::GetFrom&lt;uint8&gt;(<span class="keyword">const</span> <a class="code" href="structcelData.html" title="Typed data for CEL.">celData</a> &amp;input)
<a name="l00255"></a>00255 {
<a name="l00256"></a>00256   <span class="keywordflow">return</span> input.value.ub;
<a name="l00257"></a>00257 }
<a name="l00258"></a>00258 <span class="keyword">template</span>&lt;&gt;
<a name="l00259"></a>00259 <span class="keyword">inline</span> <span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gaa0d0fdc87fd135ef2bedb030901cdb9c">int16</a>&amp; celNNActivationFunc::GetFrom&lt;int16&gt;(<span class="keyword">const</span> <a class="code" href="structcelData.html" title="Typed data for CEL.">celData</a> &amp;input)
<a name="l00260"></a>00260 {
<a name="l00261"></a>00261   <span class="keywordflow">return</span> input.value.w;
<a name="l00262"></a>00262 }
<a name="l00263"></a>00263 <span class="keyword">template</span>&lt;&gt;
<a name="l00264"></a>00264 <span class="keyword">inline</span> <span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gac2a9e79eb120216f855626495b7bd18a">uint16</a>&amp; celNNActivationFunc::GetFrom&lt;uint16&gt;(<span class="keyword">const</span> <a class="code" href="structcelData.html" title="Typed data for CEL.">celData</a> &amp;input)
<a name="l00265"></a>00265 {
<a name="l00266"></a>00266   <span class="keywordflow">return</span> input.value.uw;
<a name="l00267"></a>00267 }
<a name="l00268"></a>00268 <span class="keyword">template</span>&lt;&gt;
<a name="l00269"></a>00269 <span class="keyword">inline</span> <span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gab7903878916593daecbeb95b98115ab0">int32</a>&amp; celNNActivationFunc::GetFrom&lt;int32&gt;(<span class="keyword">const</span> <a class="code" href="structcelData.html" title="Typed data for CEL.">celData</a> &amp;input)
<a name="l00270"></a>00270 {
<a name="l00271"></a>00271   <span class="keywordflow">return</span> input.value.l;
<a name="l00272"></a>00272 }
<a name="l00273"></a>00273 <span class="keyword">template</span>&lt;&gt;
<a name="l00274"></a>00274 <span class="keyword">inline</span> <span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gacbd4acd0d29e2d6c43104827f77d9cd2">uint32</a>&amp; celNNActivationFunc::GetFrom&lt;uint32&gt;(<span class="keyword">const</span> <a class="code" href="structcelData.html" title="Typed data for CEL.">celData</a> &amp;input)
<a name="l00275"></a>00275 {
<a name="l00276"></a>00276   <span class="keywordflow">return</span> input.value.ul;
<a name="l00277"></a>00277 }
<a name="l00278"></a>00278 
<a name="l00279"></a>00279 <span class="keyword">template</span>&lt;&gt;
<a name="l00280"></a><a class="code" href="classcelNNActivationFunc.html#a996ea992143b42b31e19b069ff04dd61">00280</a> <span class="keyword">inline</span> celDataType celNNActivationFunc::DataType&lt;int8&gt;()
<a name="l00281"></a>00281 {
<a name="l00282"></a>00282   <span class="keywordflow">return</span> CEL_DATA_BYTE;
<a name="l00283"></a>00283 }
<a name="l00284"></a>00284 <span class="keyword">template</span>&lt;&gt;
<a name="l00285"></a>00285 <span class="keyword">inline</span> celDataType celNNActivationFunc::DataType&lt;uint8&gt;()
<a name="l00286"></a>00286 {
<a name="l00287"></a>00287   <span class="keywordflow">return</span> CEL_DATA_UBYTE;
<a name="l00288"></a>00288 }
<a name="l00289"></a>00289 <span class="keyword">template</span>&lt;&gt;
<a name="l00290"></a>00290 <span class="keyword">inline</span> celDataType celNNActivationFunc::DataType&lt;int16&gt;()
<a name="l00291"></a>00291 {
<a name="l00292"></a>00292   <span class="keywordflow">return</span> CEL_DATA_WORD;
<a name="l00293"></a>00293 }
<a name="l00294"></a>00294 <span class="keyword">template</span>&lt;&gt;
<a name="l00295"></a>00295 <span class="keyword">inline</span> celDataType celNNActivationFunc::DataType&lt;uint16&gt;()
<a name="l00296"></a>00296 {
<a name="l00297"></a>00297   <span class="keywordflow">return</span> CEL_DATA_UWORD;
<a name="l00298"></a>00298 }
<a name="l00299"></a>00299 <span class="keyword">template</span>&lt;&gt;
<a name="l00300"></a>00300 <span class="keyword">inline</span> celDataType celNNActivationFunc::DataType&lt;int32&gt;()
<a name="l00301"></a>00301 {
<a name="l00302"></a>00302   <span class="keywordflow">return</span> CEL_DATA_LONG;
<a name="l00303"></a>00303 }
<a name="l00304"></a>00304 <span class="keyword">template</span>&lt;&gt;
<a name="l00305"></a>00305 <span class="keyword">inline</span> celDataType celNNActivationFunc::DataType&lt;uint32&gt;()
<a name="l00306"></a>00306 {
<a name="l00307"></a>00307   <span class="keywordflow">return</span> CEL_DATA_ULONG;
<a name="l00308"></a>00308 }
<a name="l00309"></a>00309 <span class="keyword">template</span>&lt;&gt;
<a name="l00310"></a>00310 <span class="keyword">inline</span> celDataType celNNActivationFunc::DataType&lt;float&gt;()
<a name="l00311"></a>00311 {
<a name="l00312"></a>00312   <span class="keywordflow">return</span> CEL_DATA_FLOAT;
<a name="l00313"></a>00313 }
<a name="l00314"></a>00314 
<a name="l00326"></a>00326 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00327"></a><a class="code" href="classcelNopActivationFunc.html">00327</a> <span class="keyword">class </span><a class="code" href="classcelNopActivationFunc.html" title="An identity activation function for the neural network property class.">celNopActivationFunc</a> : <span class="keyword">public</span> <a class="code" href="classcelNNActivationFunc.html" title="Abstract class representing an activation function callback for the neural network property class...">celNNActivationFunc</a>
<a name="l00328"></a>00328 {
<a name="l00329"></a>00329 <span class="keyword">public</span>:
<a name="l00330"></a><a class="code" href="classcelNopActivationFunc.html#a36f51435796ae6a0083859c9329145b3">00330</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classcelNopActivationFunc.html#a36f51435796ae6a0083859c9329145b3" title="The callback method. Performs the activation function on the data.">Function</a>(<a class="code" href="structcelData.html" title="Typed data for CEL.">celData</a> &amp;data) {}
<a name="l00331"></a><a class="code" href="classcelNopActivationFunc.html#ae4a4f686299f728df719a29f87f0186e">00331</a>   <span class="keyword">virtual</span> celDataType <a class="code" href="classcelNopActivationFunc.html#ae4a4f686299f728df719a29f87f0186e" title="Returns the type of data upon which this function operates.">GetDataType</a>() { <span class="keywordflow">return</span> DataType&lt;T&gt;(); }
<a name="l00332"></a>00332   <span class="keyword">virtual</span> ~<a class="code" href="classcelNopActivationFunc.html" title="An identity activation function for the neural network property class.">celNopActivationFunc</a>() {}
<a name="l00333"></a>00333 };
<a name="l00334"></a>00334 
<a name="l00346"></a>00346 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00347"></a><a class="code" href="classcelStepActivationFunc.html">00347</a> <span class="keyword">class </span><a class="code" href="classcelStepActivationFunc.html" title="A threshold activation function for the neural network property class.">celStepActivationFunc</a> : <span class="keyword">public</span> <a class="code" href="classcelNNActivationFunc.html" title="Abstract class representing an activation function callback for the neural network property class...">celNNActivationFunc</a>
<a name="l00348"></a>00348 {
<a name="l00349"></a>00349 <span class="keyword">public</span>:
<a name="l00350"></a><a class="code" href="classcelStepActivationFunc.html#aed07d287a04476a44ff50833f16ce326">00350</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classcelStepActivationFunc.html#aed07d287a04476a44ff50833f16ce326" title="The callback method. Performs the activation function on the data.">Function</a>(<a class="code" href="structcelData.html" title="Typed data for CEL.">celData</a> &amp;data)
<a name="l00351"></a>00351   {
<a name="l00352"></a>00352     <span class="keyword">const</span> T &amp;val = GetFrom&lt;T&gt;(data);
<a name="l00353"></a>00353     data.<a class="code" href="structcelData.html#ab9923d0fceb11a4e054e49fb212e1aed" title="Initialize and set the value.">Set</a>(T (val &gt; 1 ? 1 : 0));
<a name="l00354"></a>00354   }
<a name="l00355"></a><a class="code" href="classcelStepActivationFunc.html#aa604fe959af37bfc056c106f1d11360b">00355</a>   <span class="keyword">virtual</span> celDataType <a class="code" href="classcelStepActivationFunc.html#aa604fe959af37bfc056c106f1d11360b" title="Returns the type of data upon which this function operates.">GetDataType</a>() { <span class="keywordflow">return</span> DataType&lt;T&gt;(); }
<a name="l00356"></a>00356   <span class="keyword">virtual</span> ~<a class="code" href="classcelStepActivationFunc.html" title="A threshold activation function for the neural network property class.">celStepActivationFunc</a>() {}
<a name="l00357"></a>00357 };
<a name="l00358"></a>00358 
<a name="l00370"></a>00370 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00371"></a><a class="code" href="classcelLogActivationFunc.html">00371</a> <span class="keyword">class </span><a class="code" href="classcelLogActivationFunc.html" title="A logarithmic activation function for the neural network property class.">celLogActivationFunc</a> : <span class="keyword">public</span> <a class="code" href="classcelNNActivationFunc.html" title="Abstract class representing an activation function callback for the neural network property class...">celNNActivationFunc</a>
<a name="l00372"></a>00372 {
<a name="l00373"></a>00373 <span class="keyword">public</span>:
<a name="l00374"></a><a class="code" href="classcelLogActivationFunc.html#a4a40967497faec4395f56d738bb68729">00374</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classcelLogActivationFunc.html#a4a40967497faec4395f56d738bb68729" title="The callback method. Performs the activation function on the data.">Function</a>(<a class="code" href="structcelData.html" title="Typed data for CEL.">celData</a> &amp;data)
<a name="l00375"></a>00375   {
<a name="l00376"></a>00376     <span class="keyword">const</span> T &amp;val = GetFrom&lt;T&gt;(data);
<a name="l00377"></a>00377     <span class="keywordtype">double</span> e_v = log(fabs((<span class="keywordtype">double</span>) val)); <span class="comment">// log may return not-a-number</span>
<a name="l00378"></a>00378     data.<a class="code" href="structcelData.html#ab9923d0fceb11a4e054e49fb212e1aed" title="Initialize and set the value.">Set</a>((T) (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__geom__utils.html#ga28088446394ecb4b3a0a40443b4bf76f">csNormal</a>(e_v) ? e_v : 0.0));
<a name="l00379"></a>00379   }
<a name="l00380"></a><a class="code" href="classcelLogActivationFunc.html#a86dd194b3c115f5c98c6ba1df1e613cf">00380</a>   <span class="keyword">virtual</span> celDataType <a class="code" href="classcelLogActivationFunc.html#a86dd194b3c115f5c98c6ba1df1e613cf" title="Returns the type of data upon which this function operates.">GetDataType</a>() { <span class="keywordflow">return</span> DataType&lt;T&gt;(); }
<a name="l00381"></a>00381   <span class="keyword">virtual</span> ~<a class="code" href="classcelLogActivationFunc.html" title="A logarithmic activation function for the neural network property class.">celLogActivationFunc</a>() {}
<a name="l00382"></a>00382 };
<a name="l00383"></a>00383 
<a name="l00395"></a>00395 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00396"></a><a class="code" href="classcelAtanActivationFunc.html">00396</a> <span class="keyword">class </span><a class="code" href="classcelAtanActivationFunc.html" title="An arc-tangent activation function for the neural network property class.">celAtanActivationFunc</a> : <span class="keyword">public</span> <a class="code" href="classcelNNActivationFunc.html" title="Abstract class representing an activation function callback for the neural network property class...">celNNActivationFunc</a>
<a name="l00397"></a>00397 {
<a name="l00398"></a>00398 <span class="keyword">public</span>:
<a name="l00399"></a><a class="code" href="classcelAtanActivationFunc.html#a95c8a9664b32d3e5d48922d3b8b2b167">00399</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classcelAtanActivationFunc.html#a95c8a9664b32d3e5d48922d3b8b2b167" title="The callback method. Performs the activation function on the data.">Function</a>(<a class="code" href="structcelData.html" title="Typed data for CEL.">celData</a> &amp;data)
<a name="l00400"></a>00400   {
<a name="l00401"></a>00401     <span class="keyword">const</span> T &amp;val = GetFrom&lt;T&gt;(data);
<a name="l00402"></a>00402     data.<a class="code" href="structcelData.html#ab9923d0fceb11a4e054e49fb212e1aed" title="Initialize and set the value.">Set</a>((T) atan((<span class="keywordtype">double</span>) val));
<a name="l00403"></a>00403   }
<a name="l00404"></a><a class="code" href="classcelAtanActivationFunc.html#a6b82ce4fd8985d91ae4c61c2b2ff6a08">00404</a>   <span class="keyword">virtual</span> celDataType <a class="code" href="classcelAtanActivationFunc.html#a6b82ce4fd8985d91ae4c61c2b2ff6a08" title="Returns the type of data upon which this function operates.">GetDataType</a>() { <span class="keywordflow">return</span> DataType&lt;T&gt;(); }
<a name="l00405"></a>00405   <span class="keyword">virtual</span> ~<a class="code" href="classcelAtanActivationFunc.html" title="An arc-tangent activation function for the neural network property class.">celAtanActivationFunc</a>() {}
<a name="l00406"></a>00406 };
<a name="l00407"></a>00407 
<a name="l00420"></a>00420 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00421"></a><a class="code" href="classcelTanhActivationFunc.html">00421</a> <span class="keyword">class </span><a class="code" href="classcelTanhActivationFunc.html" title="A hyperbolic-tangent activation function for the neural network property class.">celTanhActivationFunc</a> : <span class="keyword">public</span> <a class="code" href="classcelNNActivationFunc.html" title="Abstract class representing an activation function callback for the neural network property class...">celNNActivationFunc</a>
<a name="l00422"></a>00422 {
<a name="l00423"></a>00423 <span class="keyword">public</span>:
<a name="l00424"></a><a class="code" href="classcelTanhActivationFunc.html#ad3ce715c2b152a23775c3170c110fbc4">00424</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classcelTanhActivationFunc.html#ad3ce715c2b152a23775c3170c110fbc4" title="The callback method. Performs the activation function on the data.">Function</a>(<a class="code" href="structcelData.html" title="Typed data for CEL.">celData</a> &amp;data)
<a name="l00425"></a>00425   {
<a name="l00426"></a>00426     <span class="keyword">const</span> T &amp;val = GetFrom&lt;T&gt;(data);
<a name="l00427"></a>00427     data.<a class="code" href="structcelData.html#ab9923d0fceb11a4e054e49fb212e1aed" title="Initialize and set the value.">Set</a>((T) tanh((<span class="keywordtype">double</span>) val));
<a name="l00428"></a>00428   }
<a name="l00429"></a><a class="code" href="classcelTanhActivationFunc.html#af462a53e6c5f342df6492646d1518414">00429</a>   <span class="keyword">virtual</span> celDataType <a class="code" href="classcelTanhActivationFunc.html#af462a53e6c5f342df6492646d1518414" title="Returns the type of data upon which this function operates.">GetDataType</a>() { <span class="keywordflow">return</span> DataType&lt;T&gt;(); }
<a name="l00430"></a>00430   <span class="keyword">virtual</span> ~<a class="code" href="classcelTanhActivationFunc.html" title="A hyperbolic-tangent activation function for the neural network property class.">celTanhActivationFunc</a>() {}
<a name="l00431"></a>00431 };
<a name="l00432"></a>00432 
<a name="l00444"></a>00444 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00445"></a><a class="code" href="classcelExpActivationFunc.html">00445</a> <span class="keyword">class </span><a class="code" href="classcelExpActivationFunc.html" title="An exponential activation function for the neural network property class.">celExpActivationFunc</a> : <span class="keyword">public</span> <a class="code" href="classcelNNActivationFunc.html" title="Abstract class representing an activation function callback for the neural network property class...">celNNActivationFunc</a>
<a name="l00446"></a>00446 {
<a name="l00447"></a>00447 <span class="keyword">public</span>:
<a name="l00448"></a><a class="code" href="classcelExpActivationFunc.html#acfc526896a7e2951ed0f05cf6f83dfdd">00448</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classcelExpActivationFunc.html#acfc526896a7e2951ed0f05cf6f83dfdd" title="The callback method. Performs the activation function on the data.">Function</a>(<a class="code" href="structcelData.html" title="Typed data for CEL.">celData</a> &amp;data)
<a name="l00449"></a>00449   {
<a name="l00450"></a>00450     <span class="keyword">const</span> T &amp;val = GetFrom&lt;T&gt;(data);
<a name="l00451"></a>00451     <span class="keywordtype">double</span> e_v = exp((<span class="keywordtype">double</span>) val); <span class="comment">// exp may return infinite</span>
<a name="l00452"></a>00452     data.<a class="code" href="structcelData.html#ab9923d0fceb11a4e054e49fb212e1aed" title="Initialize and set the value.">Set</a>((T) (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__geom__utils.html#ga28088446394ecb4b3a0a40443b4bf76f">csNormal</a>(e_v) ? e_v : 0.0));
<a name="l00453"></a>00453   }
<a name="l00454"></a><a class="code" href="classcelExpActivationFunc.html#a68bc03d543780392012499324f4864be">00454</a>   <span class="keyword">virtual</span> celDataType <a class="code" href="classcelExpActivationFunc.html#a68bc03d543780392012499324f4864be" title="Returns the type of data upon which this function operates.">GetDataType</a>() { <span class="keywordflow">return</span> DataType&lt;T&gt;(); }
<a name="l00455"></a>00455   <span class="keyword">virtual</span> ~<a class="code" href="classcelExpActivationFunc.html" title="An exponential activation function for the neural network property class.">celExpActivationFunc</a>() {}
<a name="l00456"></a>00456 };
<a name="l00457"></a>00457 
<a name="l00467"></a><a class="code" href="classcelInvActivationFunc.html">00467</a> <span class="keyword">class </span><a class="code" href="classcelInvActivationFunc.html" title="A reciprocal activation function for the neural network property class.">celInvActivationFunc</a> : <span class="keyword">public</span> <a class="code" href="classcelNNActivationFunc.html" title="Abstract class representing an activation function callback for the neural network property class...">celNNActivationFunc</a>
<a name="l00468"></a>00468 {
<a name="l00469"></a>00469 <span class="keyword">public</span>:
<a name="l00470"></a><a class="code" href="classcelInvActivationFunc.html#a0e4717ab9b331fa1066290db579cf292">00470</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classcelInvActivationFunc.html#a0e4717ab9b331fa1066290db579cf292" title="The callback method. Performs the activation function on the data.">Function</a>(<a class="code" href="structcelData.html" title="Typed data for CEL.">celData</a> &amp;data)
<a name="l00471"></a>00471   {
<a name="l00472"></a>00472     <span class="keyword">const</span> <span class="keywordtype">float</span> &amp;val = GetFrom&lt;float&gt;(data);
<a name="l00473"></a>00473     data.<a class="code" href="structcelData.html#ab9923d0fceb11a4e054e49fb212e1aed" title="Initialize and set the value.">Set</a>(1.0f / val);
<a name="l00474"></a>00474   }
<a name="l00475"></a><a class="code" href="classcelInvActivationFunc.html#a25a4f771f246a496ad65658991c9c2e5">00475</a>   <span class="keyword">virtual</span> celDataType <a class="code" href="classcelInvActivationFunc.html#a25a4f771f246a496ad65658991c9c2e5" title="Returns the type of data upon which this function operates.">GetDataType</a>() { <span class="keywordflow">return</span> CEL_DATA_FLOAT; }
<a name="l00476"></a>00476   <span class="keyword">virtual</span> ~<a class="code" href="classcelInvActivationFunc.html" title="A reciprocal activation function for the neural network property class.">celInvActivationFunc</a>() {}
<a name="l00477"></a>00477 };
<a name="l00478"></a>00478 
<a name="l00490"></a>00490 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00491"></a><a class="code" href="classcelSqrActivationFunc.html">00491</a> <span class="keyword">class </span><a class="code" href="classcelSqrActivationFunc.html" title="A squaring activation function for the neural network property class.">celSqrActivationFunc</a> : <span class="keyword">public</span> <a class="code" href="classcelNNActivationFunc.html" title="Abstract class representing an activation function callback for the neural network property class...">celNNActivationFunc</a>
<a name="l00492"></a>00492 {
<a name="l00493"></a>00493 <span class="keyword">public</span>:
<a name="l00494"></a><a class="code" href="classcelSqrActivationFunc.html#a4a9c580f748536ee363f4e4c1a0c2f9f">00494</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classcelSqrActivationFunc.html#a4a9c580f748536ee363f4e4c1a0c2f9f" title="The callback method. Performs the activation function on the data.">Function</a>(<a class="code" href="structcelData.html" title="Typed data for CEL.">celData</a> &amp;data)
<a name="l00495"></a>00495   {
<a name="l00496"></a>00496     <span class="keyword">const</span> T &amp;val = GetFrom&lt;T&gt;(data);
<a name="l00497"></a>00497     data.<a class="code" href="structcelData.html#ab9923d0fceb11a4e054e49fb212e1aed" title="Initialize and set the value.">Set</a>(val * val);
<a name="l00498"></a>00498   }
<a name="l00499"></a><a class="code" href="classcelSqrActivationFunc.html#a08cd34060e403a2291f1ff9fbd193d5e">00499</a>   <span class="keyword">virtual</span> celDataType <a class="code" href="classcelSqrActivationFunc.html#a08cd34060e403a2291f1ff9fbd193d5e" title="Returns the type of data upon which this function operates.">GetDataType</a>() { <span class="keywordflow">return</span> DataType&lt;T&gt;(); }
<a name="l00500"></a>00500   <span class="keyword">virtual</span> ~<a class="code" href="classcelSqrActivationFunc.html" title="A squaring activation function for the neural network property class.">celSqrActivationFunc</a>() {}
<a name="l00501"></a>00501 };
<a name="l00502"></a>00502 
<a name="l00514"></a>00514 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00515"></a><a class="code" href="classcelGaussActivationFunc.html">00515</a> <span class="keyword">class </span><a class="code" href="classcelGaussActivationFunc.html" title="An gaussian activation function for the neural network property class.">celGaussActivationFunc</a> : <span class="keyword">public</span> <a class="code" href="classcelNNActivationFunc.html" title="Abstract class representing an activation function callback for the neural network property class...">celNNActivationFunc</a>
<a name="l00516"></a>00516 {
<a name="l00517"></a>00517 <span class="keyword">public</span>:
<a name="l00518"></a><a class="code" href="classcelGaussActivationFunc.html#aed9e13d5d29ba0d123a5265db8d3fecf">00518</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classcelGaussActivationFunc.html#aed9e13d5d29ba0d123a5265db8d3fecf" title="The callback method. Performs the activation function on the data.">Function</a>(<a class="code" href="structcelData.html" title="Typed data for CEL.">celData</a> &amp;data)
<a name="l00519"></a>00519   {
<a name="l00520"></a>00520     <span class="keyword">const</span> T &amp;val = GetFrom&lt;T&gt;(data);
<a name="l00521"></a>00521     data.<a class="code" href="structcelData.html#ab9923d0fceb11a4e054e49fb212e1aed" title="Initialize and set the value.">Set</a>((T) exp((<span class="keywordtype">double</span>) -(val * val)));
<a name="l00522"></a>00522   }
<a name="l00523"></a><a class="code" href="classcelGaussActivationFunc.html#a5d385afc96a9017e4e28523709fd32db">00523</a>   <span class="keyword">virtual</span> celDataType <a class="code" href="classcelGaussActivationFunc.html#a5d385afc96a9017e4e28523709fd32db" title="Returns the type of data upon which this function operates.">GetDataType</a>() { <span class="keywordflow">return</span> DataType&lt;T&gt;(); }
<a name="l00524"></a>00524   <span class="keyword">virtual</span> ~<a class="code" href="classcelGaussActivationFunc.html" title="An gaussian activation function for the neural network property class.">celGaussActivationFunc</a>() {}
<a name="l00525"></a>00525 };
<a name="l00526"></a>00526 
<a name="l00538"></a>00538 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00539"></a><a class="code" href="classcelSinActivationFunc.html">00539</a> <span class="keyword">class </span><a class="code" href="classcelSinActivationFunc.html" title="A sine activation function for the neural network property class.">celSinActivationFunc</a> : <span class="keyword">public</span> <a class="code" href="classcelNNActivationFunc.html" title="Abstract class representing an activation function callback for the neural network property class...">celNNActivationFunc</a>
<a name="l00540"></a>00540 {
<a name="l00541"></a>00541 <span class="keyword">public</span>:
<a name="l00542"></a><a class="code" href="classcelSinActivationFunc.html#ac5cd64b71322cdff164fadd3889ba512">00542</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classcelSinActivationFunc.html#ac5cd64b71322cdff164fadd3889ba512" title="The callback method. Performs the activation function on the data.">Function</a>(<a class="code" href="structcelData.html" title="Typed data for CEL.">celData</a> &amp;data)
<a name="l00543"></a>00543   {
<a name="l00544"></a>00544     <span class="keyword">const</span> T &amp;val = GetFrom&lt;T&gt;(data);
<a name="l00545"></a>00545     data.<a class="code" href="structcelData.html#ab9923d0fceb11a4e054e49fb212e1aed" title="Initialize and set the value.">Set</a>((T) sin((<span class="keywordtype">double</span>) val));
<a name="l00546"></a>00546   }
<a name="l00547"></a><a class="code" href="classcelSinActivationFunc.html#a9536b620b8998219094d15bed7558cf7">00547</a>   <span class="keyword">virtual</span> celDataType <a class="code" href="classcelSinActivationFunc.html#a9536b620b8998219094d15bed7558cf7" title="Returns the type of data upon which this function operates.">GetDataType</a>() { <span class="keywordflow">return</span> DataType&lt;T&gt;(); }
<a name="l00548"></a>00548   <span class="keyword">virtual</span> ~<a class="code" href="classcelSinActivationFunc.html" title="A sine activation function for the neural network property class.">celSinActivationFunc</a>() {}
<a name="l00549"></a>00549 };
<a name="l00550"></a>00550 
<a name="l00562"></a>00562 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00563"></a><a class="code" href="classcelCosActivationFunc.html">00563</a> <span class="keyword">class </span><a class="code" href="classcelCosActivationFunc.html" title="A cosine activation function for the neural network property class.">celCosActivationFunc</a> : <span class="keyword">public</span> <a class="code" href="classcelNNActivationFunc.html" title="Abstract class representing an activation function callback for the neural network property class...">celNNActivationFunc</a>
<a name="l00564"></a>00564 {
<a name="l00565"></a>00565 <span class="keyword">public</span>:
<a name="l00566"></a><a class="code" href="classcelCosActivationFunc.html#af8558a3b6552b0e5330f3e2cdd082abe">00566</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classcelCosActivationFunc.html#af8558a3b6552b0e5330f3e2cdd082abe" title="The callback method. Performs the activation function on the data.">Function</a>(<a class="code" href="structcelData.html" title="Typed data for CEL.">celData</a> &amp;data)
<a name="l00567"></a>00567   {
<a name="l00568"></a>00568     <span class="keyword">const</span> T &amp;val = GetFrom&lt;T&gt;(data);
<a name="l00569"></a>00569     data.<a class="code" href="structcelData.html#ab9923d0fceb11a4e054e49fb212e1aed" title="Initialize and set the value.">Set</a>((T) cos((<span class="keywordtype">double</span>) val));
<a name="l00570"></a>00570   }
<a name="l00571"></a><a class="code" href="classcelCosActivationFunc.html#a04d86f935e737b00e90aa1ebd4b6a543">00571</a>   <span class="keyword">virtual</span> celDataType <a class="code" href="classcelCosActivationFunc.html#a04d86f935e737b00e90aa1ebd4b6a543" title="Returns the type of data upon which this function operates.">GetDataType</a>() { <span class="keywordflow">return</span> DataType&lt;T&gt;(); }
<a name="l00572"></a>00572   <span class="keyword">virtual</span> ~<a class="code" href="classcelCosActivationFunc.html" title="A cosine activation function for the neural network property class.">celCosActivationFunc</a>() {}
<a name="l00573"></a>00573 };
<a name="l00574"></a>00574 
<a name="l00586"></a>00586 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00587"></a><a class="code" href="classcelElliottActivationFunc.html">00587</a> <span class="keyword">class </span><a class="code" href="classcelElliottActivationFunc.html" title="An Elliott activation function for the neural network property class.">celElliottActivationFunc</a> : <span class="keyword">public</span> <a class="code" href="classcelNNActivationFunc.html" title="Abstract class representing an activation function callback for the neural network property class...">celNNActivationFunc</a>
<a name="l00588"></a>00588 {
<a name="l00589"></a>00589 <span class="keyword">public</span>:
<a name="l00590"></a><a class="code" href="classcelElliottActivationFunc.html#a21e2104021954e11021b88606c298f45">00590</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classcelElliottActivationFunc.html#a21e2104021954e11021b88606c298f45" title="The callback method. Performs the activation function on the data.">Function</a>(<a class="code" href="structcelData.html" title="Typed data for CEL.">celData</a> &amp;data)
<a name="l00591"></a>00591   {
<a name="l00592"></a>00592     <span class="keyword">const</span> T &amp;val = GetFrom&lt;T&gt;(data);
<a name="l00593"></a>00593     data.<a class="code" href="structcelData.html#ab9923d0fceb11a4e054e49fb212e1aed" title="Initialize and set the value.">Set</a>(val / (1 + (T)fabs((<span class="keywordtype">double</span>) val)));
<a name="l00594"></a>00594   }
<a name="l00595"></a><a class="code" href="classcelElliottActivationFunc.html#afc4156c87d48103371ffa00a74a63e4b">00595</a>   <span class="keyword">virtual</span> celDataType <a class="code" href="classcelElliottActivationFunc.html#afc4156c87d48103371ffa00a74a63e4b" title="Returns the type of data upon which this function operates.">GetDataType</a>() { <span class="keywordflow">return</span> DataType&lt;T&gt;(); }
<a name="l00596"></a>00596   <span class="keyword">virtual</span> ~<a class="code" href="classcelElliottActivationFunc.html" title="An Elliott activation function for the neural network property class.">celElliottActivationFunc</a>() {}
<a name="l00597"></a>00597 };
<a name="l00598"></a>00598 
<a name="l00610"></a>00610 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00611"></a><a class="code" href="classcelSigActivationFunc.html">00611</a> <span class="keyword">class </span><a class="code" href="classcelSigActivationFunc.html" title="A sigmoid activation function for the neural network property class.">celSigActivationFunc</a> : <span class="keyword">public</span> <a class="code" href="classcelNNActivationFunc.html" title="Abstract class representing an activation function callback for the neural network property class...">celNNActivationFunc</a>
<a name="l00612"></a>00612 {
<a name="l00613"></a>00613 <span class="keyword">public</span>:
<a name="l00614"></a><a class="code" href="classcelSigActivationFunc.html#af62931191f159b46a26bda17c2fe84b3">00614</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classcelSigActivationFunc.html#af62931191f159b46a26bda17c2fe84b3" title="The callback method. Performs the activation function on the data.">Function</a>(<a class="code" href="structcelData.html" title="Typed data for CEL.">celData</a> &amp;data)
<a name="l00615"></a>00615   {
<a name="l00616"></a>00616     <span class="keyword">const</span> T &amp;val = GetFrom&lt;T&gt;(data);
<a name="l00617"></a>00617     data.<a class="code" href="structcelData.html#ab9923d0fceb11a4e054e49fb212e1aed" title="Initialize and set the value.">Set</a>(T(1) / (T)(1 + exp((<span class="keywordtype">double</span>) -val)));
<a name="l00618"></a>00618   }
<a name="l00619"></a><a class="code" href="classcelSigActivationFunc.html#a4bd265d016a0779c29becbeff6560904">00619</a>   <span class="keyword">virtual</span> celDataType <a class="code" href="classcelSigActivationFunc.html#a4bd265d016a0779c29becbeff6560904" title="Returns the type of data upon which this function operates.">GetDataType</a>() { <span class="keywordflow">return</span> DataType&lt;T&gt;(); }
<a name="l00620"></a>00620   <span class="keyword">virtual</span> ~<a class="code" href="classcelSigActivationFunc.html" title="A sigmoid activation function for the neural network property class.">celSigActivationFunc</a>() {}
<a name="l00621"></a>00621 };
<a name="l00622"></a>00622 
<a name="l00623"></a>00623 <span class="preprocessor">#endif // __CEL_PF_NEURALNET__</span>
<a name="l00624"></a>00624 <span class="preprocessor"></span>
</pre></div></div><!-- contents -->
<hr size="1"><address><small>Generated for CEL: Crystal Entity Layer 2.0 by 
<a href="http://www.doxygen.org/index.html">doxygen</a> 1.7.6.1 
</small></address> </div></body> </html>
